<template>
    <div>
      
          <v-card tile flat v-if="loading && !initialised" height="40">
            <div class="text-center">
                Fetching data ...
              <v-progress-circular indeterminate color="primary" :width="3" :size="32"></v-progress-circular>
            </div>
          </v-card>
          <v-card flat tile align="center" justify="center" v-if="!loading && initialised === null">
            <ErrorPage title="No data Found" message="No data found matching this criteria." />
          </v-card>

        <v-card   v-if="!loading && initialised" class="app--card-container"  flat>
          <v-card-title>
            <div>
              <h1 class="title font-weight-bold">
                Permissions
              </h1>
            </div>
            <v-spacer></v-spacer>
          </v-card-title>
          
          <v-divider class="mt-2 mb-2"></v-divider>

           <v-card-text >
            <v-data-table
              flat 
              fixed-header
              disable-sort
              class="title"
              loader-height="2"
              hide-default-footer
              disable-pagination
              group-by="resource"
              :loading="loading"
              :headers="headers" 
              :items="permissions.data"
              style="overflow-x: scroll; width: 100%"
            >
               <template v-slot:header.display_name="{}">
                <v-text-field
                  solo
                  flat
                  dense
                  hide-details
                  class="ml-n4 body-2"
                  placeholder="Type to search permissions"
                  v-model="permissionsSearch"
                ></v-text-field>
              </template>
              <template v-slot:group.header="{ group }">
                <p class="ma-0 body-2 pa-3 font-weight-bold primary--text">
                  {{ group || 'General permissions' }}
                </p>
              </template>

              <template 
                v-for="(role, index) in roles.data"
                v-slot:[`item.${role.name}`]="{ item }"
              >
                <v-checkbox
                  :key="`ability-${index}`"
                  v-model="abilities[role.id]"
                  :value="item.id"
                  multiple
                  hide-details
                  dense
                  @change="syncPermission(role, item)"
                ></v-checkbox>
              </template>



              <template v-slot:item.display_name="{ item }">
                <v-hover v-slot="{ hover }">
                  <v-row>
                    {{ item.display_name }}
                    <v-spacer></v-spacer>
                    <div v-if="hover">
                      <v-tooltip 
                        right 
                        allow-overflow
                        color="#333"
                        max-width="250"
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn 
                            icon
                            x-small
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon small>
                              mdi-information-variant
                            </v-icon>
                          </v-btn>
                        </template>
                        <div class="mt-3">
                          <label class="body-2 font-weight-bold accent--text">Operational name</label>
                          <p>{{ item.name.replace('payments::', '') }}</p>
                        </div>

                        <div>
                          <label class="body-2 font-weight-bold accent--text">Display name</label>
                          <p>{{ item.display_name }}</p>
                        </div>

                        <div>
                          <label class="body-2 font-weight-bold accent--text">Description</label>
                          <p>{{ item.description }}</p>
                        </div>
                      </v-tooltip>
                      
                      <v-btn 
                        v-if="auth.can('permissions.update')"
                        icon
                        x-small
                        class="mx-1"
                        @click="permission = item"
                      >
                        <v-icon small>
                          mdi-pencil
                        </v-icon>
                      </v-btn>
                    </div>
                  </v-row>
                </v-hover>
              </template> 
            </v-data-table>
          </v-card-text>
        </v-card>
    </div>
</template>

<script>
import { mapMutations, mapGetters, mapState, mapActions } from 'vuex';
import timezoneMxn from '../../../mixins/timezoneMxn';
import Permission from '../../../libs/permissions/Permission';
import Role from '../../../libs/roles/Role';


export default {
    name: 'Permissions',

    components: {
      ErrorPage: () => import('../../../components/core/errorPage'),
    },

    data () {
      return {
        roles: null,
        loading: false,
        permissions: null,
        abilities: {},
        permissionsSearch: '',
        permissionObj: new Permission(),
        roleObj: new Role(),

      };
    },

    computed: {
        initialised () {
          return this.permissions && this.roles;
          },

        headers () {
          const roles = this.roles.data.filter(({ name }) => {
            return !name.endsWith('::admin')
          })
        
            const data = roles.map(function(role, index) {
                return {
                  text: role.display_name,
                  value: role.name,
                  ...(index != (roles.length - 1) && {
                      divider: true,
                    })
                }
            })
            data.unshift({ value: 'display_name', width: '300px', divider: true });
        
           return data;

        }
    },
    watch: {
        roles ({ data }) {
          data.forEach(role => {
           this.abilities[`${role.id}`]  = role.permissions.map(function(permission) {
                 return permission.id
                  
              });
          })
        },

        permissionsSearch (n, o) {
          if (n.length > 2) {
            this.searchPermissions()
          }

          if (!n && o) {
            this.loadPermissions()
          }
        }
    },

    async mounted () {
        this.loading = true;
        const [ roles, permissions] = await Promise.all([ this.retrieveRoles(), this.retrievePermissions() ]);
        this.loading = false;

    },

    methods: {
    ...mapActions(['requestEntityData']),

      async retrieveRoles() {
        this.roles = null;
        this.roles =  await this.roleObj.fetchPermissions();
      },

      async retrievePermissions() {
         this.permissions = null;
         this.permissions =  await this.permissionObj.fetch();
      },

      syncPermission (role, permission) {
        this.roleObj.role_id = role.id;
        this.roleObj.permission_id = permission.id;
        this.roleObj.syncPermission()
          .then(response => {
            // flash(response)
          })
    }
    }

}
</script>

<style>

</style>